﻿using System;

using Xamarin.Forms;
using System.Collections.Generic;
using Syncfusion.SfChart.XForms;
using System.Diagnostics;
using System.Collections.ObjectModel;

namespace SimpleSample
{
    public class SampleChart : ContentPage
    {
        ViewModel dataModel;

        public SampleChart()
        {
            StackLayout layout = new StackLayout() { Padding = new Thickness(5, 15, 5, 5) };

            dataModel = new ViewModel();

            var chart = new SfChart();
            chart.VerticalOptions = LayoutOptions.FillAndExpand;
            chart.HorizontalOptions = LayoutOptions.FillAndExpand;

            DateTimeAxis datetimeAxis = new DateTimeAxis();
            datetimeAxis.LabelStyle = new ChartAxisLabelStyle();
            datetimeAxis.LabelStyle.LabelFormat = "dd/MMM";
            chart.PrimaryAxis = datetimeAxis;

            NumericalAxis numericalAxis = new NumericalAxis();
            chart.SecondaryAxis = numericalAxis;
            chart.Series.Add(new ColumnSeries() { ItemsSource = dataModel.Data });
            ChartSelectionBehaviorExt selectionBehavior = new ChartSelectionBehaviorExt();
            chart.ChartBehaviors.Add(selectionBehavior);
            layout.Children.Add(chart);
            Content = layout;
        }
    }

    public class ChartSelectionBehaviorExt : ChartSelectionBehavior
    {
        protected override void OnTouchDown(float x, float y)
        {
            DateTime startdate;
			// converting double value into DateTime value
            if (Device.OS == TargetPlatform.Android)
                startdate = new DateTime(1970, 1, 1) + TimeSpan.FromMilliseconds((this.Chart.PrimaryAxis as DateTimeAxis).PointToValue(new Point(x, y)));
            else if (Device.OS == TargetPlatform.iOS)
                startdate = new DateTime(1970, 1, 1) + TimeSpan.FromSeconds((this.Chart.PrimaryAxis as DateTimeAxis).PointToValue(new Point(x, y)));
            else
                startdate = new DateTime(1900, 1, 1) + TimeSpan.FromDays((this.Chart.PrimaryAxis as DateTimeAxis).PointToValue(new Point(x, y)));
           
			Debug.WriteLine(startdate);
        }
    }
}
